*============================================================================
  File:     Sampling_Trace.sql

  Summary:  Shows how to capture a subset of events or sessions with
	    Extended Events

  Date:     April 2008

  SQL Server Version: 10.0.1300.13
------------------------------------------------------------------------------
  Copyright (C) 2008 Bob Beauchemin, SYSolutions, Inc.
  All rights reserved.

  For more scripts and sample code, check out 
    http://www.SQLskills.com

  This script is intended only as a supplement to demos and lectures
  given by Bob Beauchemin.  
  
  THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF 
  ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED 
  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
  PARTICULAR PURPOSE.
============================================================================*/

-- Sample every other session or every tenth event 
-- using the divides_by_uint64 predicate

create event session EvenSessions on server
add event sqlserver.sql_statement_completed (
action (sqlserver.session_id, sqlserver.sql_text)
where package0.divides_by_uint64 (sqlserver.session_id, 2))
add target package0.ring_buffer
with (max_dispatch_latency = 1 seconds)
 
-- or if you want to see one in ten statements this might be more appropriate:
 
create event session TenthOfAllStatements on server
add event sqlserver.sql_statement_completed (
action (sqlserver.session_id, sqlserver.sql_text)
where package0.divides_by_uint64 (package0.counter, 10))
add target package0.ring_buffer
with (max_dispatch_latency = 1 seconds)
