*============================================================================
  File:     All_Fields.sql

  Summary:  All fields for all Extended Events

  Date:     April 2008

  SQL Server Version: 10.0.1300.13
------------------------------------------------------------------------------
  Copyright (C) 2008 Bob Beauchemin, SYSolutions, Inc.
  All rights reserved.

  For more scripts and sample code, check out 
    http://www.SQLskills.com

  This script is intended only as a supplement to demos and lectures
  given by Bob Beauchemin.  
  
  THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF 
  ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED 
  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
  PARTICULAR PURPOSE.
============================================================================*/

select p.name package_name, o.name event_name, c.name event_field, 
       c.type_name field_type, c.column_type column_type
from sys.dm_xe_objects o
join sys.dm_xe_packages p
      on o.package_guid = p.guid
join sys.dm_xe_object_columns c
      on o.name = c.object_name
where o.object_type = 'event'
order by package_name, event_name

-- customizable event fields
-- these are: MDAuditId, collect_call_stack, collect_path, collect_io_data
select p.name package_name, o.name event_name, c.name event_field, 
       c.type_name field_type, c.column_type column_type
from sys.dm_xe_objects o
join sys.dm_xe_packages p
      on o.package_guid = p.guid
join sys.dm_xe_object_columns c
      on o.name = c.object_name
where o.object_type = 'event' and c.column_type = 'customizable'
order by package_name, event_name