*============================================================================
  File:     Parms_For_Add_Target.sql

  Summary:  All Extended Event target parameters

  Date:     April 2008

  SQL Server Version: 10.0.1300.13
------------------------------------------------------------------------------
  Copyright (C) 2008 Bob Beauchemin, SYSolutions, Inc.
  All rights reserved.

  For more scripts and sample code, check out 
    http://www.SQLskills.com

  This script is intended only as a supplement to demos and lectures
  given by Bob Beauchemin.  
  
  THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF 
  ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED 
  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
  PARTICULAR PURPOSE.
============================================================================*/

select p.name package_name, o.name target_name, c.name parameter_name, 
       c.type_name parameter_type, 
       case c.capabilities_desc 
       when 'mandatory' then 'yes' else 'no' 
       end required
from sys.dm_xe_objects o 
join sys.dm_xe_packages p      
on o.package_guid = p.guid
join sys.dm_xe_object_columns c      
on o.name = c.object_name and c.column_type = 'customizable'
where o.object_type = 'target' order by package_name, target_name, required desc
